pcl::OrganizedEdgeFromRGB< PointT, PointLT > Class Template Reference

`#include <pcl/features/organized_edge_detection.h>`

Inheritance diagram for pcl::OrganizedEdgeFromRGB< PointT, PointLT >:

## Public Member Functions

| OrganizedEdgeFromRGB ()
| Constructor for OrganizedEdgeFromRGB. More...
virtual | ~OrganizedEdgeFromRGB ()
| Destructor for OrganizedEdgeFromRGB. More...
void | compute (pcl::PointCloud< PointLT > &labels, std::vector< pcl::PointIndices > &label_indices) const
| Perform the 3D edge detection (edges from depth discontinuities and RGB Canny edge) and assign point indices for each edge label. More...
void | setRGBCannyLowThreshold (const float th)
| Set the low threshold value for RGB Canny edge detection. More...
float | getRGBCannyLowThreshold () const
| Get the low threshold value for RGB Canny edge detection. More...
void | setRGBCannyHighThreshold (const float th)
| Set the high threshold value for RGB Canny edge detection. More...
float | getRGBCannyHighThreshold () const
| Get the high threshold value for RGB Canny edge detection. More...
Public Member Functions inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
| OrganizedEdgeBase ()
| Constructor for OrganizedEdgeBase. More...
virtual | ~OrganizedEdgeBase ()
| Destructor for OrganizedEdgeBase. More...
void | compute (pcl::PointCloud< PointLT > &labels, std::vector< pcl::PointIndices > &label_indices) const
| Perform the 3D edge detection (edges from depth discontinuities) More...
void | setDepthDisconThreshold (const float th)
| Set the tolerance in meters for difference in depth values between neighboring points. More...
float | getDepthDisconThreshold () const
| Get the tolerance in meters for difference in depth values between neighboring points. More...
void | setMaxSearchNeighbors (const int max_dist)
| Set the max search distance for deciding occluding and occluded edges. More...
int | getMaxSearchNeighbors () const
| Get the max search distance for deciding occluding and occluded edges. More...
void | setEdgeType (int edge_types)
| Set the detecting edge types. More...
int | getEdgeType () const
| Get the detecting edge types. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | extractEdges (pcl::PointCloud< PointLT > &labels) const
| Perform the 3D edge detection (edges from depth discontinuities and RGB Canny edge) More...
Protected Member Functions inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
void | extractEdges (pcl::PointCloud< PointLT > &labels) const
| Perform the 3D edge detection (edges from depth discontinuities) and assign point indices for each edge label. More...
void | assignLabelIndices (pcl::PointCloud< PointLT > &labels, std::vector< pcl::PointIndices > &label_indices) const
| Assign point indices for each edge label. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

float | th_rgb_canny_low_
| The low threshold value for RGB Canny edge detection (default: 40.0) More...
float | th_rgb_canny_high_
| The high threshold value for RGB Canny edge detection (default: 100.0) More...
Protected Attributes inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
float | th_depth_discon_
| The tolerance in meters for difference in depth values between neighboring points (The value is set for 1 meter and is adapted with respect to depth value linearly. More...
int | max_search_neighbors_
| The max search distance for deciding occluding and occluded edges. More...
int | detecting_edge_types_
| The bit encoded value that represents edge types to detect. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Additional Inherited Members

Public Types inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
enum | { EDGELABEL_NAN_BOUNDARY =1, EDGELABEL_OCCLUDING =2, EDGELABEL_OCCLUDED =4, EDGELABEL_HIGH_CURVATURE =8, EDGELABEL_RGB_CANNY =16 }
typedef boost::shared_ptr< OrganizedEdgeBase< PointT, PointLT > > | Ptr
typedef boost::shared_ptr< const OrganizedEdgeBase< PointT, PointLT > > | ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr
Static Public Attributes inherited from pcl::OrganizedEdgeBase< PointT, PointLT >
static const int | num_of_edgetype_ = 5

## Detailed Description

### template<typename PointT, typename PointLT>
class pcl::OrganizedEdgeFromRGB< PointT, PointLT >

Definition at line 183 of file organized_edge_detection.h.

## Constructor & Destructor Documentation

## OrganizedEdgeFromRGB()

template<typename PointT , typename PointLT >

pcl::OrganizedEdgeFromRGB< PointT, PointLT >::OrganizedEdgeFromRGB | ( |  | ) |

inline

Constructor for OrganizedEdgeFromRGB.

Definition at line 205 of file organized_edge_detection.h.

References pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_NAN_BOUNDARY, pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_OCCLUDED, pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_OCCLUDING, pcl::OrganizedEdgeBase< PointT, PointLT >::EDGELABEL_RGB_CANNY, and pcl::OrganizedEdgeBase< PointT, PointLT >::setEdgeType().

## ~OrganizedEdgeFromRGB()

template<typename PointT , typename PointLT >

virtual pcl::OrganizedEdgeFromRGB< PointT, PointLT >::~OrganizedEdgeFromRGB | ( |  | ) |

inline virtual

Destructor for OrganizedEdgeFromRGB.

Definition at line 215 of file organized_edge_detection.h.

References pcl::OrganizedEdgeBase< PointT, PointLT >::compute().

## Member Function Documentation

## compute()

template<typename PointT , typename PointLT >

void pcl::OrganizedEdgeFromRGB< PointT, PointLT >::compute | ( | pcl::PointCloud< PointLT > & | labels,
|  | std::vector< pcl::PointIndices > & | label_indices
| ) |  | const

Perform the 3D edge detection (edges from depth discontinuities and RGB Canny edge) and assign point indices for each edge label.

Parameters

  [out] | labels | a PointCloud of edge labels
  [out] | label_indices | a vector of PointIndices corresponding to each edge label

Definition at line 228 of file organized_edge_detection.hpp.

References pcl::PointCloud< PointT >::height, pcl::Label::label, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

## extractEdges()

template<typename PointT , typename PointLT >

void pcl::OrganizedEdgeFromRGB< PointT, PointLT >::extractEdges | ( | pcl::PointCloud< PointLT > & | labels | ) | const

protected

Perform the 3D edge detection (edges from depth discontinuities and RGB Canny edge)

Parameters

  [out] | labels | a PointCloud of edge labels

Definition at line 244 of file organized_edge_detection.hpp.

References pcl::Edge< PointInT, PointOutT >::detectEdgeCanny(), pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::resize(), pcl::Edge< PointInT, PointOutT >::setHysteresisThresholdHigh(), pcl::Edge< PointInT, PointOutT >::setHysteresisThresholdLow(), pcl::Edge< PointInT, PointOutT >::setInputCloud(), and pcl::PointCloud< PointT >::width.

## getRGBCannyHighThreshold()

template<typename PointT , typename PointLT >

float pcl::OrganizedEdgeFromRGB< PointT, PointLT >::getRGBCannyHighThreshold | ( |  | ) | const

inline

Get the high threshold value for RGB Canny edge detection.

Definition at line 249 of file organized_edge_detection.h.

References pcl::OrganizedEdgeBase< PointT, PointLT >::extractEdges().

## getRGBCannyLowThreshold()

template<typename PointT , typename PointLT >

float pcl::OrganizedEdgeFromRGB< PointT, PointLT >::getRGBCannyLowThreshold | ( |  | ) | const

inline

Get the low threshold value for RGB Canny edge detection.

Definition at line 235 of file organized_edge_detection.h.

## setRGBCannyHighThreshold()

template<typename PointT , typename PointLT >

void pcl::OrganizedEdgeFromRGB< PointT, PointLT >::setRGBCannyHighThreshold | ( | const float | th | ) |

inline

Set the high threshold value for RGB Canny edge detection.

Definition at line 242 of file organized_edge_detection.h.

## setRGBCannyLowThreshold()

template<typename PointT , typename PointLT >

void pcl::OrganizedEdgeFromRGB< PointT, PointLT >::setRGBCannyLowThreshold | ( | const float | th | ) |

inline

Set the low threshold value for RGB Canny edge detection.

Definition at line 228 of file organized_edge_detection.h.

## Member Data Documentation

## th_rgb_canny_high_

template<typename PointT , typename PointLT >

float pcl::OrganizedEdgeFromRGB< PointT, PointLT >::th_rgb_canny_high_

protected

The high threshold value for RGB Canny edge detection (default: 100.0)

Definition at line 265 of file organized_edge_detection.h.

## th_rgb_canny_low_

template<typename PointT , typename PointLT >

float pcl::OrganizedEdgeFromRGB< PointT, PointLT >::th_rgb_canny_low_

protected

The low threshold value for RGB Canny edge detection (default: 40.0)

Definition at line 262 of file organized_edge_detection.h.

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/organized_edge_detection.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/impl/organized_edge_detection.hpp